// A simple queue implementation.
//
// The implementation uses a singly-linked list with tail pointer as the
// underlying structure.

package algos.ds

class Queue[T] {

  def isEmpty        : Boolean = data.isEmpty
  def length         : Int     = data.length
  def head           : T       = data.head
  def dequeue()      : T       = data.removeHead()
  def enqueue(x : T)             { data.append(x) }

  private val data : SinglyLinkedList[T] = new SinglyLinkedList[T]

}
