// Implements a method for permuting an array uniformly at random

package algos.random

import scala.util.Random

object RandomPermute {

  def permute[T](a : Array[T]) {
    val r = new Random
    val n = a.length
    for (i <- 0 until n-1) {
      val j = r.nextInt(n-i) + i
      val tmp = a(i)
      a(i) = a(j)
      a(j) = tmp
    }
  }

}
